/******************************************************************************
 * File: Range.impl.h
 * Date: 17.5.2018
 *****************************************************************************/

#include "Grinder.h"
#include "Range.h"
#include "util/StringConv.h"

template <typename ValType>
QString Range<ValType>::toString() const
{
	if (_range.first == _range.second)
		return StringConv::convertValue(_range.first);
	else
		return QString{"%1-%2"}.arg(StringConv::convertValue(_range.first)).arg(StringConv::convertValue(_range.second));
}

template <typename ValType>
void Range<ValType>::fromString(const QString& str)
{
	QRegExp re{"(-?\\d+)(--?\\d+)?"};

	if (re.exactMatch(str.trimmed()))
	{
		auto first = re.cap(1);
		auto second = re.cap(2);

		if (!second.isEmpty())
			second.remove(0, 1);

		_range.first = StringConv::convertString<value_type>(first);
		_range.second = !second.isEmpty() ? StringConv::convertString<value_type>(second) : _range.first;

		normalize();
	}
}
