/******************************************************************************
 * File: ObjectProperty.impl.h
 * Date: 17.4.2018
 *****************************************************************************/

#include "Grinder.h"
#include "ObjectProperty.h"

template<typename ObjType>
ObjectProperty<ObjType>::ObjectProperty(PropertyID id, QString name, Flags flags) : PropertyBase(id, name, flags)
{

}

template<typename ObjType>
void ObjectProperty<ObjType>::copyValue(const PropertyBase* property)
{
	if (auto typedProperty = dynamic_cast<const property_type*>(property))
	{
		if (!hasFlag(Flag::ReadOnly))
		{
			_object = typedProperty->_object;
			objectModified();
		}
	}
}

template<typename ObjType>
void ObjectProperty<ObjType>::serialize(SerializationContext& ctx) const
{
	PropertyBase::serialize(ctx);

	// Serialize object
	if (!hasFlag(Flag::ReadOnly))
		_object.serialize(ctx);
}

template<typename ObjType>
void ObjectProperty<ObjType>::deserialize(DeserializationContext& ctx)
{
	PropertyBase::deserialize(ctx);

	// Deserialize object
	if (!hasFlag(Flag::ReadOnly))
		_object.deserialize(ctx);
}
