/******************************************************************************
 * File: PropertyBase.cpp
 * Date: 13.1.2018
 *****************************************************************************/

#include "Grinder.h"
#include "PropertyBase.h"

const char* PropertyBase::Serialization_Value_ID = "ID";
const char* PropertyBase::Serialization_Value_Name = "Name";
const char* PropertyBase::Serialization_Value_Value = "Value";

PropertyBase::PropertyBase(PropertyID id, QString name, Flags flags) :
	_id{id}, _name{name}, _flags{flags}
{

}

void PropertyBase::serialize(SerializationContext& ctx) const
{
	// Serialize values
	ctx.settings()(Serialization_Value_ID) = _id;
	ctx.settings()(Serialization_Value_Name) = _name;
}

void PropertyBase::deserialize(DeserializationContext& ctx)
{
	_name = ctx.settings()(Serialization_Value_Name).toString();
}
