/******************************************************************************
 * File: PropertyConstraint.h
 * Date: 05.3.2018
 *****************************************************************************/

#ifndef PROPERTYCONSTRAINT_H
#define PROPERTYCONSTRAINT_H

#include <vector>
#include <memory>

namespace grndr
{
	template<typename> class Property;

	class PropertyConstraintBase
	{
	private:
		virtual void _makePolymorphic() { }	// Needed to make this class polymorphic
	};

	template<typename ValType>
	class PropertyConstraint : public PropertyConstraintBase
	{
	public:
		using value_type = ValType;

	public:
		PropertyConstraint(Property<value_type>* property);

	public:
		virtual void applyConstraint(value_type& value) = 0;

	protected:
		Property<value_type>* _property{nullptr};
	};

	using PropertyConstraints = std::vector<std::unique_ptr<PropertyConstraintBase>>;
}

#include "PropertyConstraint.impl.h"

#endif
