/******************************************************************************
 * File: PropertyObject.impl.h
 * Date: 20.3.2018
 *****************************************************************************/

#include "Grinder.h"
#include "PropertyObject.h"
#include "PropertyExceptions.h"

template<typename PropType>
std::shared_ptr<PropertyBase> PropertyObject::createProperty(PropertyID id, QString name, PropertyBase::Flags flags)
{
	return _createProperty(id, [id, name, flags](){ return std::make_shared<PropType>(id, name, flags); });
}

template<typename PropType>
std::shared_ptr<PropertyBase> PropertyObject::createProperty(PropertyID id, QString name, typename PropType::value_type defValue, PropertyBase::Flags flags)
{
	return _createProperty(id, [id, name, defValue, flags](){ return std::make_shared<PropType>(id, name, defValue, flags); });
}
