/******************************************************************************
 * File: PropertyVector.cpp
 * Date: 14.1.2018
 *****************************************************************************/

#include "Grinder.h"
#include "PropertyVector.h"

const char* PropertyVector::Serialization_Group = "Properties";
const char* PropertyVector::Serialization_Element = "Property";

void PropertyVector::copyValues(const PropertyVector& properties)
{
	// Copy values of properties which also exist in this vector
	for (const auto& property : properties)
	{
		if (auto exProperty = selectByID(property->getID()))
			exProperty->copyValue(property.get());
	}
}

PropertyVector::pointer_type PropertyVector::selectByID(PropertyID id) const
{
	return selectFirst([id](auto prop) { return prop->getID() == id; });
}
