/******************************************************************************
 * File: EvenOddConstraint.impl.h
 * Date: 05.3.2018
 *****************************************************************************/

#include "Grinder.h"
#include "EvenOddConstraint.h"

template<typename ValType>
EvenOddConstraint<ValType>::EvenOddConstraint(Property<value_type>* property, Type type) : PropertyConstraint<ValType>(property),
	_type{type}
{

}

template<typename ValType>
void EvenOddConstraint<ValType>::applyConstraint(value_type& value)
{
	bool isEven = (value & 1) == 0;

	if ((_type == Type::Even && !isEven) || (_type == Type::Odd && isEven))
		value++;
}
