/******************************************************************************
 * File: RangeConstraint.impl.h
 * Date: 05.3.2018
 *****************************************************************************/

#include "Grinder.h"
#include "RangeConstraint.h"

template<typename ValType>
RangeConstraint<ValType>::RangeConstraint(Property<value_type>* property, const value_type& minValue, const value_type& maxValue) : PropertyConstraint<ValType>(property),
	_range{minValue, maxValue}
{

}

template<typename ValType>
void RangeConstraint<ValType>::applyConstraint(value_type& value)
{
	if (value < _range.first())
		value = _range.first();

	if (value > _range.second())
		value = _range.second();
}
