/******************************************************************************
 * File: GenericController.cpp
 * Date: 08.2.2018
 *****************************************************************************/

#include "Grinder.h"
#include "GenericController.h"

GenericController::GenericController(QString typeName) :
	_controllerTypeName{typeName}
{
	if (typeName.isEmpty())
		throw std::invalid_argument{_EXCPT("typeName may not be empty")};
}

void GenericController::showControllerError(QString action, QString error) const
{
	if (!_suppressErrors)
	{
		QString str = !error.isEmpty() ? GetExceptionMessage(error) : "Unknown exception";
		QMessageBox::warning(nullptr, _controllerTypeName + " error", QString{"<b>%2 failed:</b><br>%1"}.arg(str).arg(action));
	}
}
