/******************************************************************************
 * File: ClipboardManager.cpp
 * Date: 04.4.2018
 *****************************************************************************/

#include "Grinder.h"
#include "ClipboardManager.h"
#include "GrinderApplication.h"

std::vector<SettingsContainer> ClipboardManager::getData(QString type) const
{
	if (hasData(type))
		return _data.second;
	else
		return {};
}

void ClipboardManager::setData(QString type, const std::vector<SettingsContainer>& data)
{
	_data.first = type;
	_data.second = data;

	emit dataChanged();
}

void ClipboardManager::setData(QString type, std::vector<SettingsContainer>&& data)
{
	_data.first = type;
	_data.second = std::move(data);

	emit dataChanged();
}

bool ClipboardManager::hasData(QString type) const
{
	return _data.first == type && !_data.second.empty();
}
