/******************************************************************************
 * File: GrinderExceptions.h
 * Date: 17.1.2018
 *****************************************************************************/

#ifndef GRINDEREXCEPTIONS_H
#define GRINDEREXCEPTIONS_H

#include <QString>
#include <stdexcept>

namespace grndr
{
	class GrinderException : public std::runtime_error
	{
	public:
		GrinderException(QString what) : std::runtime_error{what.toStdString()} { }
	};

	QString GetExceptionMessage(QString what, QString* func = nullptr, QString* file = nullptr, QString* line = nullptr);
	void ShowExceptionMessage(QString what);

	void InstallSignalHandlers();
}

#define _EXCPT(what)	QString{"%1|%2|%3|%4"}.arg(__func__).arg(__FILE__).arg(__LINE__).arg(what).toLatin1().data()

#endif
