/******************************************************************************
 * File: CVTypes.h
 * Date: 12.6.2018
 *****************************************************************************/

#ifndef CVTYPES_H
#define CVTYPES_H

#include <opencv2/imgproc.hpp>

namespace grndr
{
	/* Color spaces */

	enum class ColorSpace
	{
		RGB,
		HSV,
		HLS,
		CIELab,
		CIELuv,
		YUV,
	};

	/* Binary thresholding */

	enum class BinaryThresholdType
	{
		Binary = cv::THRESH_BINARY,
		BinaryInv = cv::THRESH_BINARY_INV,
		Truncate = cv::THRESH_TRUNC,
		ToZero = cv::THRESH_TOZERO,
		ToZeroInv = cv::THRESH_TOZERO_INV,
	};

	enum class BinaryThresholdMode
	{
		Manual = 0,
		Otsu = cv::THRESH_OTSU,
		Triangle = cv::THRESH_TRIANGLE,
	};

	/* Adaptive thresholding */

	enum class AdaptiveThresholdMethod
	{
		Mean = cv::ADAPTIVE_THRESH_MEAN_C,
		Gaussian = cv::ADAPTIVE_THRESH_GAUSSIAN_C,
	};

	enum class AdaptiveThresholdType
	{
		Binary = cv::THRESH_BINARY,
		BinaryInv = cv::THRESH_BINARY_INV,
	};
}

#endif
