/******************************************************************************
 * File: Engine.h
 * Date: 21.2.2018
 *****************************************************************************/

#ifndef ENGINE_H
#define ENGINE_H

#include <QObject>
#include <opencv2/core.hpp>

#include "pipeline/BlockHierarchy.h"

namespace grndr
{
	class EngineExecutionContext;
	class Label;
	class Block;
	class Port;
	class ImageReference;

	class Engine : public QObject
	{
		Q_OBJECT

	public:
		enum class ExecutionMode
		{
			Execute,
			View,
			Write,
		};

	public:
		void executeLabel(Label* label, const ImageReference* activeImageReference, ExecutionMode mode) const;
		cv::Mat executeLabelEx(Label* label, const Port* requestPort, const ImageReference* activeImageReference, ExecutionMode mode) const;

	private:
		void executeHierarchyLevel(const BlockHierarchy::HierarchyLevel& level, EngineExecutionContext& ctx, const Block* finalBlock) const;
	};
}

#endif
