/******************************************************************************
 * File: ProcessorBase.impl.h
 * Date: 20.4.2018
 *****************************************************************************/

#include "Grinder.h"
#include "ProcessorBase.h"
#include "pipeline/Block.h"

template<typename PropType>
PropType* ProcessorBase::portProperty(const Port* port, PropertyID propertyID, bool required) const
{
	if (auto dataPort = resolveDataPort(port, required))
	{
		auto property = _block->portProperty<PropType>(dataPort, propertyID);

		if (!property && required)
			throwProcessorException(QString{"No property with ID '%2' could be retrieved for port '%1'"}.arg(port->getName()).arg(propertyID));

		return property;
	}
	else
		return nullptr;
}
