/******************************************************************************
 * File: ConvertToGrayscaleProcessor.cpp
 * Date: 22.2.2018
 *****************************************************************************/

#include "Grinder.h"
#include "ConvertToGrayscaleProcessor.h"

#include <opencv2/imgproc.hpp>

ConvertToGrayscaleProcessor::ConvertToGrayscaleProcessor(const Block* block) : Processor(block)
{

}

void ConvertToGrayscaleProcessor::execute(EngineExecutionContext& ctx)
{
	Processor::execute(ctx);

	if (auto dataBlob = portData(ctx, _block->inPort()))
	{
		cv::Mat processedImage;

		if (dataBlob->dataDescriptor().isColor())	// Check if the input image really is a color one
			cv::cvtColor(dataBlob->getMatrix(), processedImage, cv::COLOR_BGR2GRAY);
		else
			processedImage = dataBlob->getMatrix();

		ctx.setContextEntry(_block->outPort(), DataBlob{getPortDataDescriptor(_block->outPort()), std::move(processedImage), dataBlob->getColorSpace()});
	}
}
