/******************************************************************************
 * File: NormalizeProcessor.cpp
 * Date: 12.6.2018
 *****************************************************************************/

#include "Grinder.h"
#include "NormalizeProcessor.h"

#include <opencv2/imgproc.hpp>

NormalizeProcessor::NormalizeProcessor(const Block* block) : Processor(block)
{

}

void NormalizeProcessor::execute(EngineExecutionContext& ctx)
{
	Processor::execute(ctx);

	if (auto dataBlob = portData(ctx, _block->inPort()))
	{
		cv::Mat processedImage;
		cv::normalize(dataBlob->getMatrix(), processedImage, *_block->lowerRange(), *_block->upperRange(), cv::NORM_MINMAX);

		ctx.setContextEntry(_block->outPort(), DataBlob{getPortDataDescriptor(_block->outPort()), std::move(processedImage), dataBlob->getColorSpace()});
	}
}
