/******************************************************************************
 * File: DraftItemCatalog.h
 * Date: 20.3.2018
 *****************************************************************************/

#ifndef DRAFTITEMCATALOG_H
#define DRAFTITEMCATALOG_H

#include <map>
#include <set>
#include <functional>
#include <memory>

#include "DraftItemType.h"

namespace grndr
{
	class DraftItem;
	class Layer;

	class DraftItemCatalog
	{
	private:
		using item_creator_type = std::function<std::unique_ptr<DraftItem>(Layer*)>;

	private:
		DraftItemCatalog() { }

	public:
		static std::unique_ptr<DraftItem> createDraftItem(Layer* layer, DraftItemType type);

		static void registerStandardDraftItems();

	public:
		static std::set<DraftItemType> getTypes();

	private:
		static void registerDraftItemType(DraftItemType type, item_creator_type creator);

	private:
		static std::map<DraftItemType, item_creator_type> s_creators;
	};
}

#endif
