/******************************************************************************
 * File: ImageBuildVector.cpp
 * Date: 12.3.2018
 *****************************************************************************/

#include "Grinder.h"
#include "ImageBuildVector.h"

const char* ImageBuildVector::Serialization_Group = "ImageBuilds";
const char* ImageBuildVector::Serialization_Element = "ImageBuild";

ImageBuildVector::pointer_vec_type ImageBuildVector::selectByImageReference(const ImageReference* imageRef) const
{
	return select([imageRef](auto build) { return std::find(build->imageReferences().cbegin(), build->imageReferences().cend(), imageRef) != build->imageReferences().cend(); });
}

ImageBuildVector::pointer_type ImageBuildVector::selectByImageReferences(const std::vector<const ImageReference*>& imageReferences) const
{
	return selectFirst([imageReferences](auto build) {
		auto compare = [](const auto& imageRef1, const auto& imageRef2) { return imageRef1 == imageRef2; };
		return std::is_permutation(build->imageReferences().cbegin(), build->imageReferences().cend(), imageReferences.cbegin(), imageReferences.cend(), compare);
	});
}
