/******************************************************************************
 * File: ImageTag.h
 * Date: 17.4.2018
 *****************************************************************************/

#ifndef IMAGETAG_H
#define IMAGETAG_H

#include <QColor>

#include "common/serialization/SerializationContext.h"
#include "common/serialization/DeserializationContext.h"

namespace grndr
{
	class ImageTags;

	class ImageTag
	{
	public:
		static const char* Serialization_Value_Name;
		static const char* Serialization_Value_Color;

	public:
		ImageTag(ImageTags* imageTags, QString name, QColor color);

	public:
		ImageTags* imageTags() { return _imageTags; }
		const ImageTags* imageTags() const { return _imageTags; }

		QString getName() const { return _name; }
		void setName(QString name) { _name = name; }
		QColor getColor() const { return _color; }
		QColor getTextColor() const;
		void setColor(QColor color) { _color = color; }

	public:
		void serialize(SerializationContext& ctx) const;
		void deserialize(DeserializationContext& ctx);

	private:
		ImageTags* _imageTags{nullptr};

		QString _name{""};
		QColor _color;
	};
}

#endif
