/******************************************************************************
 * File: BoxDraftItem.h
 * Date: 20.3.2018
 *****************************************************************************/

#ifndef BOXDRAFTITEM_H
#define BOXDRAFTITEM_H

#include "image/DraftItem.h"

namespace grndr
{
	class BoxDraftItem : public DraftItem
	{
		Q_OBJECT

	public:
		static const DraftItemType type_value;

	public:
		BoxDraftItem(Layer* layer);

	public:
		virtual std::unique_ptr<ItemRenderer> createRenderer(const ItemRenderer::RendererStyle& rendererStyle) const override;

	public:
		auto boxSize() { return dynamic_cast<SizeProperty*>(_boxSize.get()); }
		auto boxSize() const { return dynamic_cast<const SizeProperty*>(_boxSize.get()); }
		auto lineWidth() { return dynamic_cast<UIntProperty*>(_lineWidth.get()); }
		auto lineWidth() const { return dynamic_cast<const UIntProperty*>(_lineWidth.get()); }
		auto solidBox() { return dynamic_cast<BoolProperty*>(_solidBox.get()); }
		auto solidBox() const { return dynamic_cast<const BoolProperty*>(_solidBox.get()); }

	public:
		virtual void setDragPropertyValues(QPoint initialPos, QPoint currentPos) override;

		virtual void normalizePropertyValues() override;

	protected:
		virtual void createProperties() override;

	private:
		std::shared_ptr<PropertyBase> _boxSize;
		std::shared_ptr<PropertyBase> _lineWidth;
		std::shared_ptr<PropertyBase> _solidBox;
	};
}

#endif
