/******************************************************************************
 * File: LineDraftItem.h
 * Date: 20.3.2018
 *****************************************************************************/

#ifndef LINEDRAFTITEM_H
#define LINEDRAFTITEM_H

#include "image/DraftItem.h"

namespace grndr
{
	class LineDraftItem : public DraftItem
	{
		Q_OBJECT

	public:
		static const DraftItemType type_value;

	public:
		LineDraftItem(Layer* layer);

	public:
		virtual std::unique_ptr<ItemRenderer> createRenderer(const ItemRenderer::RendererStyle& rendererStyle) const override;

	public:
		virtual void setDragPropertyValues(QPoint initialPos, QPoint currentPos) override;

		virtual void setDefaultPropertyValues() override;

	public:
		auto endPosition() { return dynamic_cast<PointProperty*>(_endPosition.get()); }
		auto endPosition() const { return dynamic_cast<const PointProperty*>(_endPosition.get()); }
		auto lineWidth() { return dynamic_cast<UIntProperty*>(_lineWidth.get()); }
		auto lineWidth() const { return dynamic_cast<const UIntProperty*>(_lineWidth.get()); }

	protected:
		virtual void createProperties() override;

	private:
		std::shared_ptr<PropertyBase> _endPosition;
		std::shared_ptr<PropertyBase> _lineWidth;
	};
}

#endif
