/******************************************************************************
 * File: PixelsDraftItemRenderer.h
 * Date: 29.5.2018
 *****************************************************************************/

#ifndef PIXELSDRAFTITEMRENDERER_H
#define PIXELSDRAFTITEMRENDERER_H

#include "image/DraftItemRenderer.h"
#include "image/draftitems/PixelsDraftItem.h"
#include "image/renderers/LayerPixelsRenderer.h"

namespace grndr
{
	class LayerPixelsData;

	class PixelsDraftItemRenderer : public DraftItemRenderer<PixelsDraftItem>
	{
		Q_OBJECT

	public:
		PixelsDraftItemRenderer(const PixelsDraftItem* item, const RendererStyle& rendererStyle);

	public:
		QRect getBoundingBox() const;

	public:
		virtual void render(QPainter* painter, RenderMode mode, RenderFlags flags) override;
		virtual QPainterPath shape(RenderFlags flags) const override;

	private:
		LayerPixelsRenderer _pixelsRenderer;
	};
}

#endif
