/******************************************************************************
 * File: Block.impl.h
 * Date: 01.5.2018
 *****************************************************************************/

#include "Grinder.h"
#include "Block.h"

template<typename PropType>
PropType* Block::portProperty(PortType portType, PropertyID propertyID) const
{
	if (auto port = _ports.selectByType(portType))
		return portProperty<PropType>(port.get(), propertyID);
	else
		return nullptr;
}

template<typename PropType>
PropType* Block::portProperty(const Port* port, PropertyID propertyID) const
{
	if (auto outPort = dataPort(port))
		return outPort->block()->properties().property<PropType>(propertyID);
	else
		return nullptr;
}
