/******************************************************************************
 * File: Connection.h
 * Date: 15.1.2018
 *****************************************************************************/

#ifndef CONNECTION_H
#define CONNECTION_H

#include "PipelineItem.h"

namespace grndr
{
	class Port;
	class Block;

	class Connection : public PipelineItem
	{
		Q_OBJECT

	public:
		static const char* Serialization_Value_Source;
		static const char* Serialization_Value_Dest;

	public:
		Connection(Port* src, Port* dest);

	public:
		void initConnection();

	public:
		Block* source() { return _source(); }
		const Block* source() const { return _source(); }
		Port* sourcePort() { return _sourcePort; }
		const Port* sourcePort() const { return _sourcePort; }

		Block* dest() { return _dest(); }
		const Block* dest() const { return _dest(); }
		Port* destPort() { return _destPort; }
		const Port* destPort() const { return _destPort; }

	public:
		virtual void serialize(SerializationContext& ctx) const override;
		virtual void deserialize(DeserializationContext& ctx) override;

	private:
		Block* _source() const;
		Block* _dest() const;

	private:
		Port* _sourcePort{nullptr};
		Port* _destPort{nullptr};	
	};

}

#endif
