/******************************************************************************
 * File: ConnectionVector.cpp
 * Date: 15.1.2018
 *****************************************************************************/

#include "Grinder.h"
#include "ConnectionVector.h"

const char* ConnectionVector::Serialization_Group = "Connections";
const char* ConnectionVector::Serialization_Element = "Connection";

ConnectionVector::ConnectionVector(const Port* srcPort) :
	_sourcePort{srcPort}
{
	if (!srcPort)
		throw std::invalid_argument{_EXCPT("srcPort may not be null")};
}

ConnectionVector::pointer_type ConnectionVector::selectByDestination(const Port* dest) const
{
	return selectFirst([dest](auto con) { return con->destPort() == dest; });
}
