/******************************************************************************
 * File: PipelineItem.cpp
 * Date: 13.1.2018
 *****************************************************************************/

#include "Grinder.h"
#include "PipelineItem.h"
#include "PipelineExceptions.h"

const char* PipelineItem::Serialization_Value_Name = "Name";

PipelineItem::PipelineItem(Pipeline* pipeline, QString name) :
	_pipeline{pipeline}, _name{name}
{
	if (!pipeline)
		throw std::invalid_argument{_EXCPT("pipeline may not be null")};
}

void PipelineItem::initPipelineItem()
{
	createProperties();
}

void PipelineItem::serialize(SerializationContext& ctx) const
{
	PropertyObject::serialize(ctx);

	// Serialize values
	ctx.settings()(Serialization_Value_Name) = _name;
}

void PipelineItem::deserialize(DeserializationContext& ctx)
{
	PropertyObject::deserialize(ctx);

	// Deserialize values
	_name = ctx.settings()(Serialization_Value_Name).toString();
}
