/******************************************************************************
 * File: ConvertToColorBlock.h
 * Date: 12.6.2018
 *****************************************************************************/

#ifndef CONVERTTOCOLORBLOCK_H
#define CONVERTTOCOLORBLOCK_H

#include "pipeline/Block.h"
#include "pipeline/properties/ColorSpaceProperty.h"

namespace grndr
{
	class ConvertToColorBlock : public Block
	{
		Q_OBJECT

	public:
		static const BlockType type_value;
		static const BlockCategory category_value;

	public:
		ConvertToColorBlock(Pipeline* pipeline, QString name = "");

	public:
		virtual std::unique_ptr<ProcessorBase> createProcessor() const override;

	public:
		auto colorSpace() { return dynamic_cast<ColorSpaceProperty*>(_colorSpace.get()); }
		auto colorSpace() const { return dynamic_cast<const ColorSpaceProperty*>(_colorSpace.get()); }

		Port* inPort() { return _inPort.get(); }
		const Port* inPort() const { return _inPort.get(); }
		Port* outPort() { return _outPort.get(); }
		const Port* outPort() const { return _outPort.get(); }

	protected:		
		virtual void createProperties() override;
		virtual void createPorts() override;

	private:
		std::shared_ptr<PropertyBase> _colorSpace;

		std::shared_ptr<Port> _inPort;
		std::shared_ptr<Port> _outPort;
	};
}

#endif
