/******************************************************************************
 * File: InputBlock.cpp
 * Date: 03.2.2018
 *****************************************************************************/

#include "Grinder.h"
#include "InputBlock.h"
#include "core/GrinderApplication.h"
#include "engine/processors/InputProcessor.h"

const BlockType InputBlock::type_value = BlockType::Input;
const BlockCategory InputBlock::category_value = BlockCategory::Input;

InputBlock::InputBlock(Pipeline* pipeline, QString name) : Block(pipeline, type_value, category_value, name)
{

}

std::unique_ptr<ProcessorBase> InputBlock::createProcessor() const
{
	return std::make_unique<InputProcessor>(this);
}

void InputBlock::createProperties()
{
	Block::createProperties();

	_imageReference = createProperty<ImageReferenceProperty>(PropertyID::ImageReference, "Image", nullptr);
	imageReference()->setDescription("The image to use as the input; can either be the currently active image or a fixed one.");
}

void InputBlock::createPorts()
{
	_outPort = createPort(PortType::ImageOut, Port::Direction::Out, {DataDescriptor::imageDescriptor()}, "Out");
}
