/******************************************************************************
 * File: MergeChannelsBlock.cpp
 * Date: 14.6.2018
 *****************************************************************************/

#include "Grinder.h"
#include "MergeChannelsBlock.h"
#include "engine/processors/MergeChannelsProcessor.h"

const BlockType MergeChannelsBlock::type_value = BlockType::MergeChannels;
const BlockCategory MergeChannelsBlock::category_value = BlockCategory::Conversion;

MergeChannelsBlock::MergeChannelsBlock(Pipeline* pipeline, QString name) : Block(pipeline, type_value, category_value, name)
{

}

std::unique_ptr<ProcessorBase> MergeChannelsBlock::createProcessor() const
{
	return std::make_unique<MergeChannelsProcessor>(this);
}

void MergeChannelsBlock::createPorts()
{
	DataDescriptors inPortDataDescs = {DataDescriptor::imageDescriptor(false, DataDescriptor::ValueType::Any)};
	_channel1Port = createPort(PortType::ImageChannel1, Port::Direction::In, inPortDataDescs, "Channel 1");
	_channel2Port = createPort(PortType::ImageChannel2, Port::Direction::In, inPortDataDescs, "Channel 2");
	_channel3Port = createPort(PortType::ImageChannel3, Port::Direction::In, inPortDataDescs, "Channel 3");

	DataDescriptors outPortDataDescs = {DataDescriptor::imageDescriptor(true, DataDescriptor::ValueType::Dynamic)};
	_outPort = createPort(PortType::ImageOut, Port::Direction::Out, outPortDataDescs, "Out");
}
