/******************************************************************************
 * File: MergeChannelsBlock.h
 * Date: 14.6.2018
 *****************************************************************************/

#ifndef MERGECHANNELSBLOCK_H
#define MERGECHANNELSBLOCK_H

#include "pipeline/Block.h"

namespace grndr
{
	class MergeChannelsBlock : public Block
	{
		Q_OBJECT

	public:
		static const BlockType type_value;
		static const BlockCategory category_value;

	public:
		MergeChannelsBlock(Pipeline* pipeline, QString name = "");

	public:
		virtual std::unique_ptr<ProcessorBase> createProcessor() const override;

	public:		
		Port* channel1Port() { return _channel1Port.get(); }
		const Port* channel1Port() const { return _channel1Port.get(); }
		Port* channel2Port() { return _channel2Port.get(); }
		const Port* channel2Port() const { return _channel2Port.get(); }
		Port* channel3Port() { return _channel3Port.get(); }
		const Port* channel3Port() const { return _channel3Port.get(); }
		Port* outPort() { return _outPort.get(); }
		const Port* outPort() const { return _outPort.get(); }

	protected:
		virtual void createPorts() override;

	private:
		std::shared_ptr<Port> _channel1Port;
		std::shared_ptr<Port> _channel2Port;
		std::shared_ptr<Port> _channel3Port;
		std::shared_ptr<Port> _outPort;
	};
}

#endif
