/******************************************************************************
 * File: NormalizeBlock.h
 * Date: 12.6.2018
 *****************************************************************************/

#ifndef NORMALIZEBLOCK_H
#define NORMALIZEBLOCK_H

#include "pipeline/Block.h"

namespace grndr
{
	class NormalizeBlock : public Block
	{
		Q_OBJECT

	public:
		static const BlockType type_value;
		static const BlockCategory category_value;

	public:
		NormalizeBlock(Pipeline* pipeline, QString name = "");

	public:
		virtual std::unique_ptr<ProcessorBase> createProcessor() const override;

	public:
		auto lowerRange() { return dynamic_cast<UIntProperty*>(_lowerRange.get()); }
		auto lowerRange() const { return dynamic_cast<const UIntProperty*>(_lowerRange.get()); }
		auto upperRange() { return dynamic_cast<UIntProperty*>(_upperRange.get()); }
		auto upperRange() const { return dynamic_cast<const UIntProperty*>(_upperRange.get()); }

		Port* inPort() { return _inPort.get(); }
		const Port* inPort() const { return _inPort.get(); }
		Port* outPort() { return _outPort.get(); }
		const Port* outPort() const { return _outPort.get(); }

	protected:
		virtual void createProperties() override;
		virtual void createPorts() override;

	private:
		std::shared_ptr<PropertyBase> _lowerRange;
		std::shared_ptr<PropertyBase> _upperRange;

		std::shared_ptr<Port> _inPort;
		std::shared_ptr<Port> _outPort;
	};
}

#endif
