/******************************************************************************
 * File: ReplaceColorBlock.h
 * Date: 19.6.2018
 *****************************************************************************/

#ifndef REPLACECOLORBLOCK_H
#define REPLACECOLORBLOCK_H

#include "pipeline/Block.h"

namespace grndr
{
	class ReplaceColorBlock : public Block
	{
		Q_OBJECT

	public:
		static const BlockType type_value;
		static const BlockCategory category_value;

	public:
		ReplaceColorBlock(Pipeline* pipeline, QString name = "");

	public:
		virtual std::unique_ptr<ProcessorBase> createProcessor() const override;

	public:
		auto fromColor() { return dynamic_cast<ColorProperty*>(_fromColor.get()); }
		auto fromColor() const { return dynamic_cast<const ColorProperty*>(_fromColor.get()); }
		auto toColor() { return dynamic_cast<ColorProperty*>(_toColor.get()); }
		auto toColor() const { return dynamic_cast<const ColorProperty*>(_toColor.get()); }
		auto tolerance() { return dynamic_cast<UIntProperty*>(_tolerance.get()); }
		auto tolerance() const { return dynamic_cast<const UIntProperty*>(_tolerance.get()); }

		Port* inPort() { return _inPort.get(); }
		const Port* inPort() const { return _inPort.get(); }
		Port* outPort() { return _outPort.get(); }
		const Port* outPort() const { return _outPort.get(); }

	protected:
		virtual void createProperties() override;
		virtual void createPorts() override;

	private:
		std::shared_ptr<PropertyBase> _fromColor;
		std::shared_ptr<PropertyBase> _toColor;
		std::shared_ptr<PropertyBase> _tolerance;

		std::shared_ptr<Port> _inPort;
		std::shared_ptr<Port> _outPort;
	};
}

#endif
