/******************************************************************************
 * File: SplitChannelsBlock.cpp
 * Date: 14.6.2018
 *****************************************************************************/

#include "Grinder.h"
#include "SplitChannelsBlock.h"
#include "engine/processors/SplitChannelsProcessor.h"

const BlockType SplitChannelsBlock::type_value = BlockType::SplitChannels;
const BlockCategory SplitChannelsBlock::category_value = BlockCategory::Conversion;

SplitChannelsBlock::SplitChannelsBlock(Pipeline* pipeline, QString name) : Block(pipeline, type_value, category_value, name)
{

}

std::unique_ptr<ProcessorBase> SplitChannelsBlock::createProcessor() const
{
	return std::make_unique<SplitChannelsProcessor>(this);
}

void SplitChannelsBlock::createPorts()
{
	DataDescriptors inPortDataDescs = {DataDescriptor::imageDescriptor(true, DataDescriptor::ValueType::Any)};
	_inPort = createPort(PortType::ImageIn, Port::Direction::In, inPortDataDescs, "In");

	DataDescriptors outPortDataDescs = {DataDescriptor::imageDescriptor(false, DataDescriptor::ValueType::Dynamic)};
	_channel1Port = createPort(PortType::ImageChannel1, Port::Direction::Out, outPortDataDescs, "Channel 1");
	_channel2Port = createPort(PortType::ImageChannel2, Port::Direction::Out, outPortDataDescs, "Channel 2");
	_channel3Port = createPort(PortType::ImageChannel3, Port::Direction::Out, outPortDataDescs, "Channel 3");
}
