/******************************************************************************
 * File: ImageReferenceVector.h
 * Date: 10.2.2018
 *****************************************************************************/

#ifndef IMAGEREFERENCEVECTOR_H
#define IMAGEREFERENCEVECTOR_H

#include "common/ObjectVector.h"
#include "ImageReference.h"

namespace grndr
{
	class ImageReferenceVector : public ObjectVector<ImageReference>
	{
	public:
		enum class Neighbor
		{
			Previous,
			Next,
		};

	public:
		static const char* Serialization_Group;
		static const char* Serialization_Element;

	public:
		pointer_type selectByFilePath(QString filePath) const;
		pointer_type selectByFileName(QString fileName) const;		

	public:
		pointer_type getNeighbor(const ImageReference* imageReference, Neighbor neighbor) const;				
	};
}

#endif
