/******************************************************************************
 * File: ProjectExceptions.cpp
 * Date: 07.2.2018
 *****************************************************************************/

#include "Grinder.h"
#include "ProjectExceptions.h"
#include "Label.h"
#include "ImageReference.h"

ProjectException::ProjectException(const Project* project, QString what) : GrinderException{what},
	_project{project}
{

}

LabelException::LabelException(const Label* label, QString what) : ProjectException(label ? label->project() : nullptr, what),
	_label{label}
{

}

ImageReferenceException::ImageReferenceException(const ImageReference* imageRef, QString what) : ProjectException(imageRef ? imageRef->project() : nullptr, what),
	_imageReference{imageRef}
{

}
