/******************************************************************************
 * File: StyleSheet.h
 * Date: 02.2.2018
 *****************************************************************************/

#ifndef GLOBALSTYLESHEET_H
#define GLOBALSTYLESHEET_H

#include <QString>
#include <QColor>

namespace grndr
{
	class StyleSheet final
	{
	public:
		static QString loadStyleSheet(QString name);

	private:
		StyleSheet() { }

	private:
		static void replacePlaceholders(QString& styleSheet);
		static void replaceColorPlaceholder(QString& styleSheet, QString name, QColor color);

		static void removeConditionalLines(QString& styleSheet);
		static bool checkConditions(const QStringList& conditions);
	};
}

#endif
