/******************************************************************************
 * File: TemporaryStatusMessage.cpp
 * Date: 10.2.2018
 *****************************************************************************/

#include "Grinder.h"
#include "TemporaryStatusMessage.h"
#include "core/GrinderApplication.h"

TemporaryStatusMessage::TemporaryStatusMessage(QString message)
{
	setMessage(message);
}

TemporaryStatusMessage::~TemporaryStatusMessage()
{
	if (grinder()->mainWindow())
	{
		grinder()->mainWindow()->statusBar()->clearMessage();
		QApplication::processEvents(QEventLoop::ExcludeUserInputEvents);
	}
}

void TemporaryStatusMessage::setMessage(QString message) const
{
	if (!message.isEmpty() && grinder()->mainWindow())
	{
		grinder()->mainWindow()->statusBar()->showMessage(message);
		QApplication::processEvents(QEventLoop::ExcludeUserInputEvents);
	}
}
