/******************************************************************************
 * File: CheckListDialog.impl.h
 * Date: 25.4.2018
 *****************************************************************************/

#include "Grinder.h"
#include "CheckListDialog.h"
#include "ui/widgets/CheckListWidget.h"

template<typename ObjectType, typename ItemType, typename ContainerType>
std::vector<ObjectType*> CheckListDialog::exec(const ContainerType& container, const std::vector<ObjectType*>& checkedObjects, bool* accepted)
{
	// Create a check list widget for the given types and add it to the dialog
	auto checkListWidget = new CheckListWidget<ObjectType, ItemType>{};
	setCheckListWidget(checkListWidget);

	checkListWidget->populateList(container);
	checkListWidget->setCheckedObjects(checkedObjects);

	if (accepted)
		*accepted = false;

	if (QDialog::exec() == QDialog::Accepted)
	{
		if (accepted)
			*accepted = true;

		return checkListWidget->getCheckedObjects();
	}
	else
		return {};
}
