/******************************************************************************
 * File: GraphBlockList.h
 * Date: 03.2.2018
 *****************************************************************************/

#ifndef GRAPHBLOCKLIST_H
#define GRAPHBLOCKLIST_H

#include <QFrame>
#include <QLabel>
#include <QLayout>

#include "pipeline/BlockCategory.h"
#include "pipeline/BlockType.h"
#include "ui/DragInfo.h"

#define GRAPHBLOCKLIST_DRAG_MIMETYPE	"application/x-blocktype"

namespace grndr
{
	class PipelineManager;
	class Pipeline;

	class GraphBlockList : public QFrame
	{
		Q_OBJECT

	public:
		GraphBlockList(QWidget* parent = nullptr);

	protected:
		virtual bool eventFilter(QObject *obj, QEvent* event) override;

		virtual void mouseMoveEvent(QMouseEvent *event) override;

	private:
		void createBlockList();
		void createBlockCategoryEntry(BlockCategory category);
		void createBlockTypeEntry(BlockType type);

	private slots:
		void pipelineSwitched(Pipeline* pipeline) const { updateBlockTypeButtonStates(pipeline != nullptr); }

		void blockTypeButtonPressed();

	private:
		void updateBlockTypeButtonStates(bool enable) const;

	private:
		QVBoxLayout* _layout{nullptr};

		DragInfo _dragInfo;
	};
}

#endif
