/******************************************************************************
 * File: GraphConnectionBase.h
 * Date: 27.1.2018
 *****************************************************************************/

#ifndef GRAPHCONNECTIONBASE_H
#define GRAPHCONNECTIONBASE_H

#include "GraphNode.h"
#include "GraphStyle.h"

namespace grndr
{
	class GraphConnectionBase : public GraphNode
	{
		Q_OBJECT

	public:
		GraphConnectionBase(GraphScene* scene, QGraphicsItem* parent = nullptr);

	public:
		virtual QPainterPath shape() const override;
		virtual QRectF boundingRect() const override;

	protected:
		void drawConnection(QPainter* painter, QColor sourceColor, QColor destColor);

	protected:
		virtual void updateGeometry() override;

		virtual QPointF calcSourcePosition() const = 0;
		virtual QPointF calcDestPosition() const = 0;

		struct
		{
			QPointF sourcePosition;
			QPointF destPosition;

			QPainterPath connectionPath;
		} _geometry;

	protected:
		const GraphStyle::ConnectionNodeStyle& _connectionStyle;
	};
}

#endif
