/******************************************************************************
 * File: GraphConnectionMessage.cpp
 * Date: 29.1.2018
 *****************************************************************************/

#include "Grinder.h"
#include "GraphConnectionMessage.h"

GraphConnectionMessage::GraphConnectionMessage(grndr::GraphScene* scene, QGraphicsItem* parent) : GraphNode(scene, parent),
	_connectionStyle{_style.getConnectionMessageStyle()}
{
	setFlag(ItemIsFocusable, false);
	setFlag(ItemIsSelectable, false);
	setFlag(ItemSendsGeometryChanges, false);
}


void GraphConnectionMessage::paint(QPainter* painter, const QStyleOptionGraphicsItem* option, QWidget* widget)
{
	Q_UNUSED(option);
	Q_UNUSED(widget);

	painter->setRenderHints(QPainter::Antialiasing|QPainter::TextAntialiasing|QPainter::HighQualityAntialiasing|QPainter::SmoothPixmapTransform);

	// Draw the background
	QColor color = _connectionStyle.blueprintInvalidColor;

	painter->setOpacity(_connectionStyle.messageOpacity);

	painter->save();
	painter->setPen(QPen{color, 0.0});
	painter->setBrush(color);
	painter->drawRoundedRect(_nodeRect, _connectionStyle.borderRadius, _connectionStyle.borderRadius);
	painter->restore();

	// Draw the text
	painter->setPen(_connectionStyle.messageColor);
	painter->setFont(_connectionStyle.messageFont);
	painter->drawText(_nodeRect, Qt::AlignHCenter|Qt::AlignVCenter, _text);
}

void GraphConnectionMessage::updateGeometry()
{
	QFontMetricsF fontMetrics{_connectionStyle.messageFont};
	_geometry._textRect = QRectF{0.0, 0.0, fontMetrics.width(_text), fontMetrics.height()};

	_nodeRect = _geometry._textRect + _connectionStyle.messageMargins;
	_nodeRectSelected = _nodeRect;
}
