/******************************************************************************
 * File: GraphNodeFactory.h
 * Date: 22.1.2018
 *****************************************************************************/

#ifndef GRAPHNODEFACTORY_H
#define GRAPHNODEFACTORY_H

#include "ui/visscene/VisualNodeFactory.h"
#include "pipeline/BlockType.h"

namespace grndr
{
	class GraphScene;
	class GraphBlockNode;
	class Block;

	class GraphNodeFactory : public VisualNodeFactory<GraphBlockNode, Block, BlockType, GraphScene>
	{
	public:
		GraphNodeFactory(GraphScene* scene);

	protected:
		virtual GraphBlockNode* createDefaultNode(const std::shared_ptr<Block>& block) const override;

	private:
		void registerStandardBlocks();
	};
}

#endif
