/******************************************************************************
 * File: GraphStyle.cpp
 * Date: 20.1.2018
 *****************************************************************************/

#include "Grinder.h"
#include "GraphStyle.h"

QColor GraphStyle::BlockNodeStyle::getBlockCategoryColor(BlockCategory category) const
{
	if (category == BlockCategory::Input)
		return QColor{220, 0, 20};
	else if (category == BlockCategory::Output)
		return QColor{100, 0, 140};
	else if (category == BlockCategory::Conversion)
		return QColor{0, 80, 140};
	else if (category == BlockCategory::Thresholding)
		return QColor{100, 220, 0};
	else if (category == BlockCategory::Blending)
		return QColor{40, 180, 200};
	else if (category == BlockCategory::Annotation)
		return QColor{240, 200, 60};
	else
		return QColor{255, 255, 255};
}

GraphStyle::NodeStyle::NodeStyle()
{
	font.setStyleStrategy(QFont::StyleStrategy(QFont::PreferAntialias|QFont::PreferQuality));
}

GraphStyle::BlockNodeStyle::BlockNodeStyle()
{
	nameFont.setPointSize(10);
	nameFont.setBold(true);
	nameFont.setStyleStrategy(QFont::StyleStrategy(QFont::PreferAntialias|QFont::PreferQuality));

	typeFont.setPointSize(8);
	typeFont.setStyleStrategy(QFont::StyleStrategy(QFont::PreferAntialias|QFont::PreferQuality));
}

GraphStyle::GraphStyle()
{
	_viewStyle.defaultSceneSize = {4000.0f, 2000.0f};
}
