/******************************************************************************
 * File: GraphWidget.h
 * Date: 02.2.2018
 *****************************************************************************/

#ifndef GRAPHCONTAINERWIDGET_H
#define GRAPHCONTAINERWIDGET_H

#include <QFrame>
#include <QGridLayout>

namespace grndr
{
	class GraphView;
	class GraphBlockList;

	class GraphWidget : public QFrame
	{
		Q_OBJECT

	public:
		GraphWidget(QWidget* parent = nullptr);

	public:
		GraphView* graphView() { return _graphView; }
		const GraphView* graphView() const { return _graphView; }
		GraphBlockList* graphBlockList() { return _graphBlockList; }
		const GraphBlockList* graphBlockList() const { return _graphBlockList; }

	private:
		QGridLayout* _layout{nullptr};

		GraphView* _graphView{nullptr};
		GraphBlockList* _graphBlockList{nullptr};
	};
}

#endif
