/******************************************************************************
 * File: BaseImageTagsListWidget.h
 * Date: 18.4.2018
 *****************************************************************************/

#ifndef BASEIMAGETAGSLISTWIDGET_H
#define BASEIMAGETAGSLISTWIDGET_H

#include "ui/widgets/MetaWidget.h"
#include "ui/widgets/ObjectListWidget.h"
#include "ImageTagsListItem.h"

namespace grndr
{
	class ImageTags;

	using ImageTagsObjectListWidget = ObjectListWidget<ImageTag, ImageTagsListItem>;

	class BaseImageTagsListWidget : public MetaWidget<ImageTagsObjectListWidget>
	{
		Q_OBJECT

	public:
		BaseImageTagsListWidget(QWidget* parent = nullptr);

	public:
		virtual void assignImageTags(ImageTags* imageTags);

	protected slots:
		virtual void updateActions() { }

	private slots:		
		void imageTagAdded(const std::shared_ptr<ImageTag>& imageTag);
		void imageTagRemoved(const std::shared_ptr<ImageTag>& imageTag);
		void imageTagModified(const std::shared_ptr<ImageTag>& imageTag);

	protected:
		ImageTags* _imageTags{nullptr};
	};
}

#endif
