/******************************************************************************
 * File: ColorPresetsWidget.h
 * Date: 03.4.2018
 *****************************************************************************/

#ifndef COLORPRESETSWIDGET_H
#define COLORPRESETSWIDGET_H

#include <QGridLayout>

#include "ui/widgets/ColorWidget.h"

namespace grndr
{
	class ColorPresetsWidget : public QWidget
	{
		Q_OBJECT

	public:
		ColorPresetsWidget(QWidget* parent = nullptr);

	public:
		void assignUiComponents(QWidget* actionOwner);

	public:
		QColor getColor(unsigned int index) const { return _colorPresets[index].presetWidget->getColor(); }
		void setColor(unsigned int index, QColor color) { _colorPresets[index].presetWidget->setColor(color); }

		auto getPresetsCount() const { return _colorPresets.size(); }

	signals:
		void colorSelected(QColor color);

	private:
		void createPresetWidgets();
		QAction* createAction(unsigned int index, QWidget* owner);

	private slots:
		void presetSelected(QColor color);
		void presetActionTriggered();

	private:
		QGridLayout* _layout{nullptr};

		struct PresetEntry
		{
			ColorWidget* presetWidget;
			QAction* presetAction{nullptr};
		};

		std::vector<PresetEntry> _colorPresets;
	};
}

#endif
