/******************************************************************************
 * File: DraftItemNodeFactory.h
 * Date: 21.3.2018
 *****************************************************************************/

#ifndef DRAFTITEMNODEFACTORY_H
#define DRAFTITEMNODEFACTORY_H

#include "ui/visscene/VisualNodeFactory.h"
#include "image/DraftItemType.h"

namespace grndr
{
	class ImageEditorScene;	
	class DraftItem;
	class DraftItemNode;

	class DraftItemNodeFactory : public VisualNodeFactory<DraftItemNode, DraftItem, DraftItemType, ImageEditorScene>
	{
	public:
		DraftItemNodeFactory(ImageEditorScene* scene);

	protected:
		virtual DraftItemNode* createDefaultNode(const std::shared_ptr<DraftItem>& item) const override;

	private:
		void registerStandardDraftItems();
	};
}

#endif
