/******************************************************************************
 * File: EditableImageTagsListWidget.h
 * Date: 01.5.2018
 *****************************************************************************/

#ifndef EDITABLEIMAGETAGSLISTWIDGET_H
#define EDITABLEIMAGETAGSLISTWIDGET_H

#include "BaseImageTagsListWidget.h"

namespace grndr
{
	class EditableImageTagsListWidget : public BaseImageTagsListWidget
	{
		Q_OBJECT

	public:
		EditableImageTagsListWidget(QWidget* parent = nullptr);

	public:
		virtual void assignImageTags(ImageTags* imageTags) override;

	protected:
		virtual std::unique_ptr<QMenu> createContextMenu() const override;

		virtual std::vector<QAction*> getActions(AddActionsMode mode) const override;

	protected:
		virtual void mouseDoubleClickEvent(QMouseEvent* event) override;

	protected slots:
		virtual void updateActions() override;

	private slots:
		void newImageTag();
		void editImageTag();
		void removeImageTag();
		void removeAllImageTags();

	private:
		QAction* _newImageTagAction{nullptr};
		QAction* _editImageTagAction{nullptr};
		QAction* _removeImageTagAction{nullptr};
		QAction* _removeAllImageTagsAction{nullptr};
	};
}

#endif
