/******************************************************************************
 * File: ImageEditorScene.impl.h
 * Date: 21.3.2018
 *****************************************************************************/

#include "Grinder.h"
#include "ImageEditorScene.h"
#include "DraftItemNode.h"
#include "LayerPixelsNode.h"

template<typename ValType>
std::vector<ValType*> ImageEditorScene::_findLayerItemNodes(const Layer* layer) const
{
	std::vector<ValType*> nodes;

	for (const auto& node : items())
	{
		if (auto itemNode = dynamic_cast<ValType*>(node))
		{
			if (!layer || itemNode->layer() == layer)
				nodes.push_back(itemNode);
		}
	}

	return nodes;
}
