/******************************************************************************
 * File: ImageTagDialog.h
 * Date: 19.4.2018
 *****************************************************************************/

#ifndef IMAGETAGDIALOG_H
#define IMAGETAGDIALOG_H

#include <QDialog>

namespace Ui
{
	class ImageTagDialog;
}

namespace grndr
{
	class ImageTag;

	class ImageTagDialog : public QDialog
	{
		Q_OBJECT

	public:
		ImageTagDialog(ImageTag* imageTag, bool newTag, QWidget* parent = nullptr);
		~ImageTagDialog();

	public slots:
		virtual void accept() override;

	private:
		void setupUi(bool newTag);
		Ui::ImageTagDialog *ui;

	private slots:
		void on_txtImageTagName_textChanged(const QString& text);

	private:
		void verifyImageTagProperties() const;
		void applyImageTagProperties(bool save);

	private:
		ImageTag* _imageTag{nullptr};
	};
}

#endif
