/******************************************************************************
 * File: InPlaceEditor.h
 * Date: 27.3.2018
 *****************************************************************************/

#ifndef INPLACEEDITOR_H
#define INPLACEEDITOR_H

#include "ImageEditorNode.h"
#include "InPlaceEditorDragHandle.h"

namespace grndr
{
	class DraftItemNode;

	class InPlaceEditor : public ImageEditorNode
	{
		Q_OBJECT

	public:
		InPlaceEditor(ImageEditorScene* scene, DraftItemNode* draftItemNode);

	public:
		virtual void updateEditor() = 0;

	public:
		virtual void paint(QPainter* painter, const QStyleOptionGraphicsItem *option, QWidget* widget) override;

	protected:
		virtual QVariant itemChange(GraphicsItemChange change, const QVariant& value) override;

	protected:
		InPlaceEditorDragHandle* createDragHandle(InPlaceEditorDragHandle::AllowedDirections allowedDirections, QPointF position = QPointF{0.0, 0.0});

		virtual void dragHandlePressed(InPlaceEditorDragHandle* dragHandle) { Q_UNUSED(dragHandle); }
		virtual void dragHandleMoved(InPlaceEditorDragHandle* dragHandle, QPoint offset) { Q_UNUSED(dragHandle); Q_UNUSED(offset); }
		virtual void dragHandleReleased(InPlaceEditorDragHandle* dragHandle);

	private slots:
		void handlePressed();
		void handleMoved(QPoint offset);
		void handleReleased();

	protected:
		DraftItemNode* _draftItemNode{nullptr};	
	};
}

#endif
