/******************************************************************************
 * File: LayerItemNode.cpp
 * Date: 15.6.2018
 *****************************************************************************/

#include "Grinder.h"
#include "LayerItemNode.h"
#include "image/Layer.h"

LayerItemNode::LayerItemNode(ImageEditorScene* scene, Layer* layer, QGraphicsItem* parent) : ImageEditorNode(scene, parent),
	_layer{layer}
{
	if (!layer)
		throw std::invalid_argument{_EXCPT("layer may not be null")};
}

void LayerItemNode::updateNode()
{
	prepareGeometryChange();
	updateGeometry();

	update();
}

void LayerItemNode::updateZOrder()
{
	setZValue(_layer->getZOrder());	// Use the z-order of the layer
}

void LayerItemNode::updateVisibility()
{
	setVisible(_layer->isVisible());	// Use the visibility flag of the layer
}

void LayerItemNode::updateAlpha()
{
	setOpacity(_layer->getAlpha() / 100.0f);	// Use the alpha value of the layer
}
