/******************************************************************************
 * File: LayerItemNode.h
 * Date: 15.6.2018
 *****************************************************************************/

#ifndef LAYERITEMNODE_H
#define LAYERITEMNODE_H

#include "ImageEditorNode.h"

namespace grndr
{
	class Layer;

	class LayerItemNode : public ImageEditorNode
	{
		Q_OBJECT

	public:
		LayerItemNode(ImageEditorScene* scene, Layer* layer, QGraphicsItem* parent = nullptr);

	public:
		Layer* layer() { return _layer; }
		const Layer* layer() const { return _layer; }

	public slots:
		virtual void updateNode();

		virtual void updateZOrder();
		virtual void updateVisibility();
		virtual void updateAlpha();

	protected:
		Layer* _layer{nullptr};
	};
}

#endif
