/******************************************************************************
 * File: LayerPixelsNode.cpp
 * Date: 18.5.2018
 *****************************************************************************/

#include "Grinder.h"
#include "LayerPixelsNode.h"
#include "ImageEditorStyle.h"
#include "image/Layer.h"

LayerPixelsNode::LayerPixelsNode(ImageEditorScene* scene, Layer* layer, QGraphicsItem* parent) : LayerItemNode(scene, layer, parent)
{
	setFlags(0);	// This item doesn't behave like an item at all

	// Create the renderer for the layer pixels
	_renderer = layer->layerPixels().createRenderer(_style.getItemNodeStyle());

	// Update the node whenever the pixels data has changed
	connect(&layer->layerPixels().data(), &LayerPixelsData::dataModified, this, &LayerPixelsNode::updateNode);

	updateZOrder();
	updateVisibility();
	updateAlpha();

	updateNode();
}

void LayerPixelsNode::updateZOrder()
{
	setZValue(_layer->getZOrder() - 0.1);	// Place the pixels just below all other items
}

void LayerPixelsNode::updateGeometry()
{
	_nodeRect = _nodeRectSelected = _layer->layerPixels().data().bounds();
	ImageEditorNode::updateGeometry();
}
