/******************************************************************************
 * File: LayersListItem.h
 * Date: 17.3.2018
 *****************************************************************************/

#ifndef LAYERSLISTITEM_H
#define LAYERSLISTITEM_H

#include "ui/widgets/ActiveObjectListItem.h"
#include "image/Layer.h"

namespace grndr
{
	class LayersListItem : public ActiveObjectListItem<Layer>
	{
	public:
		LayersListItem(Layer* layer);

	public:
		virtual void updateItem() override;

	public:
		QString getName() const { return _object->getName(); }
		Layer::Type getType() const { return _object->getType(); }
		bool isVisible() const { return _object->isVisible(); }
		bool isRemovable() const { return _object->isRemovable(); }

	private:
		QFont _specialFont;
		QFont _specialActiveFont;
	};
}

#endif
