/******************************************************************************
 * File: BoxDraftItemNode.h
 * Date: 23.3.2018
 *****************************************************************************/

#ifndef BOXDRAFTITEMNODE_H
#define BOXDRAFTITEMNODE_H

#include "image/draftitems/BoxDraftItem.h"
#include "ui/image/DraftItemNode.h"

namespace grndr
{
	class BoxDraftItemNode : public DraftItemNode
	{
		Q_OBJECT

	public:
		static const DraftItemType type_value;

	public:
		BoxDraftItemNode(ImageEditorScene* scene, const std::shared_ptr<DraftItem>& item, QGraphicsItem* parent = nullptr);

		auto boxDraftItem() { return std::dynamic_pointer_cast<BoxDraftItem>(_draftItem.lock()); }
		auto boxDraftItem() const { return std::dynamic_pointer_cast<const BoxDraftItem>(_draftItem.lock()); }

	protected:
		virtual std::unique_ptr<InPlaceEditor> createInPlaceEditor() override;

	protected:
		virtual QRect getBoundingRect() const override;
	};
}

#endif
