/******************************************************************************
 * File: LineDraftItemNode.h
 * Date: 23.3.2018
 *****************************************************************************/

#ifndef LINEDRAFTITEMNODE_H
#define LINEDRAFTITEMNODE_H

#include "image/DraftItemType.h"
#include "ui/image/DraftItemNode.h"
#include "image/draftitems/LineDraftItem.h"

namespace grndr
{
	class LineDraftItemNode : public DraftItemNode
	{
		Q_OBJECT

	public:
		static const DraftItemType type_value;

	public:
		LineDraftItemNode(ImageEditorScene* scene, const std::shared_ptr<DraftItem>& item, QGraphicsItem* parent = nullptr);

	public:
		auto lineDraftItem() { return std::dynamic_pointer_cast<LineDraftItem>(_draftItem.lock()); }
		auto lineDraftItem() const { return std::dynamic_pointer_cast<const LineDraftItem>(_draftItem.lock()); }

	protected:
		virtual std::unique_ptr<InPlaceEditor> createInPlaceEditor() override;

	protected:
		virtual QVariant itemChange(GraphicsItemChange change, const QVariant& value) override;

	protected:
		virtual QRect getBoundingRect() const override;
	};
}

#endif
