/******************************************************************************
 * File: PixelsDraftItemNode.cpp
 * Date: 29.5.2018
 *****************************************************************************/

#include "Grinder.h"
#include "PixelsDraftItemNode.h"
#include "image/renderers/PixelsDraftItemRenderer.h"
#include "util/MathUtils.h"

const DraftItemType PixelsDraftItemNode::type_value = DraftItemType::Pixels;

PixelsDraftItemNode::PixelsDraftItemNode(ImageEditorScene* scene, const std::shared_ptr<DraftItem>& item, QGraphicsItem* parent) : DraftItemNode(scene, item, parent)
{
	// Whenever the pixels data has changed, update this node
	if (auto draftItem = pixelsDraftItem())	// Make sure that the underlying draft item still exists
		connect(&draftItem->pixelsData(), &LayerPixelsData::dataModified, this, &PixelsDraftItemNode::updateNode);

	updateNode();
}

QRect PixelsDraftItemNode::getBoundingRect() const
{
	// Use the renderer's shape to get the bounding rectangle
	if (_renderer)
		return _renderer->shape(getRenderFlags()).boundingRect().toRect();
	else
		return QRect{};
}
