/******************************************************************************
 * File: RectangularInPlaceEditor.h
 * Date: 29.3.2018
 *****************************************************************************/

#ifndef RECTANGULARINPLACEEDITOR_H
#define RECTANGULARINPLACEEDITOR_H

#include "ui/image/InPlaceEditor.h"
#include "common/properties/StandardProperties.h"

namespace grndr
{
	class RectangularInPlaceEditor : public InPlaceEditor
	{
		Q_OBJECT

	public:
		RectangularInPlaceEditor(ImageEditorScene* scene, DraftItemNode* draftItemNode, PointProperty* position, SizeProperty* size);

	public:
		virtual void updateEditor() override;

	protected:
		virtual void dragHandleMoved(InPlaceEditorDragHandle* dragHandle, QPoint offset) override;

	private:
		void updateDragHandlePositions();

	private:
		PointProperty* _position{nullptr};
		SizeProperty* _size{nullptr};

		std::vector<InPlaceEditorDragHandle*> _dragHandles;
	};
}

#endif
