/******************************************************************************
 * File: BoxDraftItemTool.cpp
 * Date: 22.3.2018
 *****************************************************************************/

#include "Grinder.h"
#include "BoxDraftItemTool.h"
#include "res/Resources.h"

const char* BoxDraftItemTool::tool_type = "BoxDraftItemTool";

BoxDraftItemTool::BoxDraftItemTool(ImageEditor* imageEditor) : DraftItemTool(imageEditor, DraftItemType::Box, "Bounding box", FILE_ICON_EDITOR_BOX, "B", QCursor{QPixmap{FILE_CURSOR_EDITOR_BOX}, 0, 0})
{

}

void BoxDraftItemTool::createProperties()
{
	DraftItemTool::createProperties();

	// Create specific properties
	_boxSize = createProperty<SizeProperty>(PropertyID::Size, "Size", QSize{50, 50});
	boxSize()->setDescription("The size of the box.");

	_lineWidth = createProperty<UIntProperty>(PropertyID::Width, "Line width", 5);
	lineWidth()->createConstraint<RangeConstraint>(1, 100);
	lineWidth()->setDescription("The width of the box lines.");	

	_solidBox = createProperty<BoolProperty>(PropertyID::Solid, "Solid box", false);
	solidBox()->setDescription("Fill the entire box.");

	// Override some property defaults
	hasDirection()->setValue(true);
}
