/******************************************************************************
 * File: BoxDraftItemTool.h
 * Date: 22.3.2018
 *****************************************************************************/

#ifndef BOXDRAFTITEMTOOL_H
#define BOXDRAFTITEMTOOL_H

#include "DraftItemTool.h"

namespace grndr
{
	class BoxDraftItemTool : public DraftItemTool
	{
	public:
		static const char* tool_type;

	public:
		BoxDraftItemTool(ImageEditor* imageEditor);

	public:
		virtual QString getToolType() const override { return tool_type; }

	public:
		auto boxSize() { return dynamic_cast<SizeProperty*>(_boxSize.get()); }
		auto boxSize() const { return dynamic_cast<const SizeProperty*>(_boxSize.get()); }
		auto lineWidth() { return dynamic_cast<UIntProperty*>(_lineWidth.get()); }
		auto lineWidth() const { return dynamic_cast<const UIntProperty*>(_lineWidth.get()); }
		auto solidBox() { return dynamic_cast<BoolProperty*>(_solidBox.get()); }
		auto solidBox() const { return dynamic_cast<const BoolProperty*>(_solidBox.get()); }

	protected:
		virtual void createProperties() override;

	private:
		std::shared_ptr<PropertyBase> _boxSize;
		std::shared_ptr<PropertyBase> _lineWidth;		
		std::shared_ptr<PropertyBase> _solidBox;
	};
}

#endif
