/******************************************************************************
 * File: EraserTool.h
 * Date: 21.5.2018
 *****************************************************************************/

#ifndef ERASERTOOL_H
#define ERASERTOOL_H

#include "PaintbrushTool.h"
#include "ui/visscene/RubberBandNode.h"

namespace grndr
{
	class EraserTool : public PaintbrushTool
	{
	public:
		static const char* tool_type;

	public:
		EraserTool(ImageEditor* imageEditor);

	public:
		virtual QString getToolType() const override { return tool_type; }

	public:
		virtual void toolDeactivated(ImageEditorTool* nextTool) override { Q_UNUSED(nextTool); removeRubberBand(); }

	protected:
		virtual void createProperties() override;

	protected:
		virtual InputEventResult rightMousePressed(const QGraphicsSceneMouseEvent* event) override;
		virtual InputEventResult rightMouseMoved(const QGraphicsSceneMouseEvent* event) override;
		virtual InputEventResult rightMouseReleased(const QGraphicsSceneMouseEvent* event) override;

	private:
		void createRubberBand(QPointF pos);
		void removeRubberBand();

	private:
		RubberBandNode* _rubberBandNode{nullptr};
	};
}

#endif
