/******************************************************************************
 * File: LineDraftItemTool.cpp
 * Date: 22.3.2018
 *****************************************************************************/

#include "Grinder.h"
#include "LineDraftItemTool.h"
#include "res/Resources.h"

const char* LineDraftItemTool::tool_type = "LineDraftItemTool";

LineDraftItemTool::LineDraftItemTool(ImageEditor* imageEditor) : DraftItemTool(imageEditor, DraftItemType::Line, "Line", FILE_ICON_EDITOR_LINE, "L", QCursor{QPixmap{FILE_CURSOR_EDITOR_LINE}, 0, 0})
{

}

void LineDraftItemTool::createProperties()
{
	DraftItemTool::createProperties();

	// Create specific properties
	_lineWidth = createProperty<UIntProperty>(PropertyID::Width, "Line width", 3);
	lineWidth()->createConstraint<RangeConstraint>(1, 100);
	lineWidth()->setDescription("The width of the line.");
}
