/******************************************************************************
 * File: LineDraftItemTool.h
 * Date: 22.3.2018
 *****************************************************************************/

#ifndef LINEDRAFTITEMTOOL_H
#define LINEDRAFTITEMTOOL_H

#include "DraftItemTool.h"

namespace grndr
{
	class LineDraftItemTool : public DraftItemTool
	{
	public:
		static const char* tool_type;

	public:
		LineDraftItemTool(ImageEditor* imageEditor);

	public:
		virtual QString getToolType() const override { return tool_type; }

	public:
		auto lineWidth() { return dynamic_cast<UIntProperty*>(_lineWidth.get()); }
		auto lineWidth() const { return dynamic_cast<const UIntProperty*>(_lineWidth.get()); }

	protected:
		virtual void createProperties() override;

	private:
		std::shared_ptr<PropertyBase> _lineWidth;
	};
}

#endif
