/******************************************************************************
 * File: PaintbrushTool.h
 * Date: 21.5.2018
 *****************************************************************************/

#ifndef PAINTBRUSHTOOL_H
#define PAINTBRUSHTOOL_H

#include "ui/image/ImageEditorTool.h"

namespace grndr
{
	class PaintbrushTool : public ImageEditorTool
	{
	public:
		static const char* tool_type;

	public:		
		PaintbrushTool(ImageEditor* imageEditor);
		PaintbrushTool(ImageEditor* imageEditor, QString name, QString icon, QString shortcut, QCursor cursor = QCursor{Qt::ArrowCursor});

	public:
		virtual QString getToolType() const override { return tool_type; }

	public:
		auto penWidth() { return dynamic_cast<UIntProperty*>(_penWidth.get()); }
		auto penWidth() const { return dynamic_cast<const UIntProperty*>(_penWidth.get()); }

	protected:
		virtual void createProperties() override;

	protected:
		virtual InputEventResult mousePressed(const QGraphicsSceneMouseEvent* event) override;
		virtual InputEventResult mouseMoved(const QGraphicsSceneMouseEvent* event) override;
		virtual InputEventResult mouseReleased(const QGraphicsSceneMouseEvent* event) override { Q_UNUSED(event); return InputEventResult::Process; }
		virtual InputEventResult rightMousePressed(const QGraphicsSceneMouseEvent* event) override;
		virtual InputEventResult rightMouseMoved(const QGraphicsSceneMouseEvent* event) override;
		virtual InputEventResult rightMouseReleased(const QGraphicsSceneMouseEvent* event) override { Q_UNUSED(event); return InputEventResult::Process; }

	protected:
		void paintPixel(QPoint pos, bool erase = false) const;

	protected:
		std::shared_ptr<PropertyBase> _penWidth;

		bool _eraseByDefault{false};
		QPoint _lastPixelPos;	
	};
}

#endif
