/******************************************************************************
 * File: ZoomTool.h
 * Date: 05.6.2018
 *****************************************************************************/

#ifndef ZOOMTOOL_H
#define ZOOMTOOL_H

#include "ui/image/ImageEditorTool.h"
#include "ui/visscene/RubberBandNode.h"

namespace grndr
{
	class ZoomTool : public ImageEditorTool
	{
	public:
		static const char* tool_type;

	public:
		ZoomTool(ImageEditor* imageEditor);

	public:
		virtual QString getToolType() const override { return tool_type; }

	public:
		virtual void toolDeactivated(ImageEditorTool* nextTool) override { Q_UNUSED(nextTool); removeRubberBand(); }

	protected:
		virtual InputEventResult mousePressed(const QGraphicsSceneMouseEvent* event) override;
		virtual InputEventResult mouseMoved(const QGraphicsSceneMouseEvent* event) override;
		virtual InputEventResult mouseReleased(const QGraphicsSceneMouseEvent* event) override;

	private:
		void createRubberBand(QPointF pos);
		void removeRubberBand();

	private:
		RubberBandNode* _rubberBandNode{nullptr};
	};
}

#endif
