/******************************************************************************
 * File: LabelsListWidget.h
 * Date: 07.2.2018
 *****************************************************************************/

#ifndef LABELSLISTWIDGET_H
#define LABELSLISTWIDGET_H

#include "ui/widgets/MetaWidget.h"
#include "ui/widgets/ActiveObjectListWidget.h"
#include "LabelsListItem.h"

namespace grndr
{
	class Label;

	using LabelObjectListWidget = ActiveObjectListWidget<Label, LabelsListItem>;

	class LabelsListWidget : public MetaWidget<LabelObjectListWidget>
	{
		Q_OBJECT

	public:
		LabelsListWidget(QWidget* parent = nullptr);

	protected:
		virtual std::unique_ptr<QMenu> createContextMenu() const override;

		virtual std::vector<QAction*> getActions(AddActionsMode mode) const override;

	protected:
		virtual void switchToObjectItem(LabelsListItem* item, bool selectItem = true) override;

	private slots:
		void switchLabel() { switchToObjectItem(currentObjectItem()); }
		void renameLabel() { editItem(currentItem()); }		
		void newLabel();
		void removeLabel();
		void removeAllLabels();

		void labelSwitched(Label* label);
		void labelRenamed(QWidget* editor) const;

		void updateActions();

	private:
		QAction* _switchLabelAction{nullptr};
		QAction* _renameLabelAction{nullptr};
		QAction* _newLabelAction{nullptr};
		QAction* _removeLabelAction{nullptr};
		QAction* _removeAllLabelsAction{nullptr};
	};
}

#endif
