/******************************************************************************
 * File: PropertyEditor.h
 * Date: 07.3.2018
 *****************************************************************************/

#ifndef PROPERTYEDITOR_H
#define PROPERTYEDITOR_H

#include <QWidget>

#include "PropertyEditorBase.h"

namespace grndr
{
	class PropertyBase;

	template<typename Base, typename PropertyType = PropertyBase>
	class PropertyEditor : public Base, public PropertyEditorBase
	{
		static_assert(std::is_base_of<QWidget, Base>::value, "Base must be derived from QWidget");

	public:
		using widget_type = PropertyEditor<Base, PropertyType>;
		using base_type = Base;
		using property_type = PropertyType;

	public:
		PropertyEditor(PropertyType* property, QWidget* parent = nullptr);

	protected:
		virtual void showEvent(QShowEvent* event) override;

	protected:
		QString getPropertyValue() const;
		void setPropertyValue(const QString& value);

		virtual void applyPropertyValue() = 0;

	protected:
		PropertyType* _property{nullptr};
	};
}

#include "PropertyEditor.impl.h"

#endif
