/******************************************************************************
 * File: PropertyTreeItem.h
 * Date: 06.3.2018
 *****************************************************************************/

#ifndef PROPERTYTREEITEM_H
#define PROPERTYTREEITEM_H

#include <QTreeWidgetItem>
#include <memory>

namespace grndr
{
	class PipelineItem;
	class PropertyBase;
	class PropertyTreeItem;

	class _PropertyTreeItemHelper : public QObject
	{
		Q_OBJECT

		friend class PropertyTreeItem;

	public slots:
		void updateItem();

	private:
		_PropertyTreeItemHelper(PropertyTreeItem* treeItem) : _treeItem{treeItem} { }
		PropertyTreeItem* _treeItem{nullptr};
	};

	class PropertyTreeItem : public QTreeWidgetItem
	{
	public:
		PropertyTreeItem();

	public:
		virtual void updateItem() = 0;

	protected:
		std::unique_ptr<_PropertyTreeItemHelper> _helper;
	};
}

#endif
