/******************************************************************************
 * File: BoolPropertyEditor.cpp
 * Date: 07.3.2018
 *****************************************************************************/

#include "Grinder.h"
#include "BoolPropertyEditor.h"

BoolPropertyEditor::BoolPropertyEditor(BoolProperty* property, QWidget *parent) : PropertyEditor(property, parent)
{
	setText("Enable");

	applyPropertyValue();

	// Update the property whenever the checkbox has been toggled
	connect(this, &QCheckBox::toggled, this, &BoolPropertyEditor::itemChecked);
}

void BoolPropertyEditor::applyPropertyValue()
{
	setChecked(_property->getValue());
}

void BoolPropertyEditor::itemChecked(bool checked)
{
	_property->setValue(checked);
}
