/******************************************************************************
 * File: ColorPropertyEditor.cpp
 * Date: 19.6.2018
 *****************************************************************************/

#include "Grinder.h"
#include "ColorPropertyEditor.h"

ColorPropertyEditor::ColorPropertyEditor(ColorProperty* property, QWidget *parent) : PropertyEditor(property, parent)
{
	applyPropertyValue();

	// Update the property whenever the checkbox has been toggled
	connect(this, &ColorWidget::colorChanged, this, &ColorPropertyEditor::colorChanged);
}

void ColorPropertyEditor::applyPropertyValue()
{
	setColor(_property->getValue());
}

void ColorPropertyEditor::colorChanged(QColor color, bool byUser)
{
	if (byUser)
		_property->setValue(color);
}
