/******************************************************************************
 * File: ColorPropertyEditor.h
 * Date: 19.6.2018
 *****************************************************************************/

#ifndef COLORPROPERTYEDITOR_H
#define COLORPROPERTYEDITOR_H

#include <QCheckBox>

#include "common/properties/types/ColorProperty.h"
#include "ui/properties/PropertyEditor.h"
#include "ui/widgets/ColorWidget.h"

namespace grndr
{
	class ColorPropertyEditor : public PropertyEditor<ColorWidget, ColorProperty>
	{
		Q_OBJECT

	public:
		ColorPropertyEditor(ColorProperty* property, QWidget *parent = nullptr);

	protected:
		virtual void applyPropertyValue() override;

	private slots:
		void colorChanged(QColor color, bool byUser);
	};
}

#endif
