/******************************************************************************
 * File: EnumPropertyEditor.cpp
 * Date: 12.4.2018
 *****************************************************************************/

#ifndef ENUMPROPERTYEDITOR_H
#define ENUMPROPERTYEDITOR_H

#include <QComboBox>

#include "common/properties/types/EnumPropertyBase.h"
#include "ui/properties/PropertyEditor.h"

namespace grndr
{
	class EnumPropertyEditor : public PropertyEditor<QComboBox, EnumPropertyBase>
	{
		Q_OBJECT

	public:
		EnumPropertyEditor(EnumPropertyBase* property, QWidget *parent = nullptr);

	protected:
		virtual void applyPropertyValue() override;

	private slots:
		void populateEnumValues();
		void currentIndexChanged(int index);
	};
}

#endif
