/******************************************************************************
 * File: RealPropertyEditor.h
 * Date: 07.6.2018
 *****************************************************************************/

#ifndef REALPROPERTYEDITOR_H
#define REALPROPERTYEDITOR_H

#include "common/properties/PropertyConstraint.h"
#include "ui/widgets/AutoFocusWidget.h"
#include "ui/properties/PropertyEditor.h"

namespace grndr
{
	class RealPropertyEditor : public PropertyEditor<AutoFocusDoubleSpinBox>
	{
		Q_OBJECT

	public:
		RealPropertyEditor(PropertyBase* property, const PropertyConstraints* constraints, QWidget* parent = nullptr);

	protected:
		virtual void applyPropertyValue() override;

	private:
		void applyPropertyConstraints(const PropertyConstraints& constraints);

	private slots:
		void valueChanged();
	};
}

#endif
