/******************************************************************************
 * File: SizePropertyEditor.cpp
 * Date: 07.3.2018
 *****************************************************************************/

#include "Grinder.h"
#include "SizePropertyEditor.h"
#include "util/StringConv.h"

SizePropertyEditor::SizePropertyEditor(SizeProperty* property, QWidget* parent) : DualIntPropertyEditor(property, "w:", "h:", Range<int>::fullRange(), Range<int>::fullRange(), parent)
{
	applyPropertyValue();	
}

void SizePropertyEditor::applyPropertyValue()
{
	auto size = _property->getValue();

	_spinBox1->setValue(size.width());
	_spinBox2->setValue(size.height());
}

void SizePropertyEditor::valuesChanged()
{
	QSize size;

	size.setWidth(_spinBox1->value());
	size.setHeight(_spinBox2->value());

	setPropertyValue(StringConv::convertValue(size));
}
