/******************************************************************************
 * File: RubberBandNode.h
 * Date: 05.6.2018
 *****************************************************************************/

#ifndef RUBBERBANDNODE_H
#define RUBBERBANDNODE_H

#include <QRubberBand>
#include <QGraphicsProxyWidget>

namespace grndr
{
	class RubberBandNode : public QObject
	{
		Q_OBJECT

	public:
		RubberBandNode(QGraphicsScene* scene, QPointF pos);
		virtual ~RubberBandNode();

	public:
		void move(QPointF pos);

	public:
		QRect getRect() const { if (_rubberBand) return _rubberBand->geometry(); else return QRect{}; }

	private:
		QGraphicsScene* _scene{nullptr};

		QRubberBand* _rubberBand{nullptr};
		QGraphicsProxyWidget* _rubberBandNode{nullptr};

		QPointF _startPosition;
	};
}

#endif
