/******************************************************************************
 * File: ActiveObjectListItem.h
 * Date: 25.4.2018
 *****************************************************************************/

#ifndef ACTIVEOBJECTLISTITEM_H
#define ACTIVEOBJECTLISTITEM_H

#include "ObjectListItem.h"

namespace grndr
{
	template<typename ObjectType>
	class ActiveObjectListItem : public ObjectListItem<ObjectType>
	{
	public:
		ActiveObjectListItem(ObjectType* object);

	public:
		virtual void updateItem();

	public:
		bool isActive() const { return _isActive; }
		void setActive(bool active) { _isActive = active; updateItem(); }

	protected:
		bool _isActive{false};

	private:
		QFont _regularFont;
		QFont _activeFont;
	};
}

#include "ActiveObjectListItem.impl.h"

#endif
