/******************************************************************************
 * File: ActiveObjectListWidget.impl.h
 * Date: 25.4.2018
 *****************************************************************************/

#include "Grinder.h"
#include "ActiveObjectListWidget.h"

template<typename ObjectType, typename ItemType>
ObjectType* ActiveObjectListWidget<ObjectType, ItemType>::activeObject() const
{
	auto item = activeObjectItem();

	if (item)
		return item->object();
	else
		return nullptr;
}


template<typename ObjectType, typename ItemType>
void ActiveObjectListWidget<ObjectType, ItemType>::mouseDoubleClickEvent(QMouseEvent* event)
{
	auto item = dynamic_cast<item_type*>(this->itemAt(event->pos()));

	if (item)
		switchToObjectItem(item);
	else
		ObjectListWidget<ObjectType, ItemType>::mouseDoubleClickEvent(event);
}

template<typename ObjectType, typename ItemType>
void ActiveObjectListWidget<ObjectType, ItemType>::setCurrentObjectItem(item_type* item)
{
	ObjectListWidget<ObjectType, ItemType>::setCurrentObjectItem(item);
	switchToObjectItem(item);
}

template<typename ObjectType, typename ItemType>
void ActiveObjectListWidget<ObjectType, ItemType>::objectSwitched(object_type* obj)
{
	for (int i = 0; i < this->count(); ++i)
	{
		if (auto item = this->objectItem(i))
			item->setActive(item->object() == obj);
	}

	this->update();
}

template<typename ObjectType, typename ItemType>
ItemType* ActiveObjectListWidget<ObjectType, ItemType>::activeObjectItem() const
{
	for (int i = 0; i < this->count(); ++i)
	{
		if (auto item = this->objectItem(i))
		{
			if (item->isActive())
				return item;
		}
	}

	return nullptr;
}
