/******************************************************************************
 * File: CheckListWidget.h
 * Date: 25.4.2018
 *****************************************************************************/

#ifndef CHECKLISTWIDGET_H
#define CHECKLISTWIDGET_H

#include "ObjectListWidget.h"

namespace grndr
{
	template<typename ObjectType, typename ItemType>
	class CheckListWidget : public ObjectListWidget<ObjectType, ItemType>
	{
	public:
		using object_type = ObjectType;
		using item_type = ItemType;

	public:
		CheckListWidget(QWidget* parent = nullptr);

		template<typename ContainerType>
		void populateList(const ContainerType& container);

		std::vector<ObjectType*> getCheckedObjects() const;
		void setCheckedObjects(const std::vector<ObjectType*>& checkedObjects);

	protected:
		virtual void contextMenuEvent(QContextMenuEvent* event) override;

	private:
		QAction* _unCheckSelectedItems{nullptr};
		QAction* _checkAllItems{nullptr};
		QAction* _uncheckAllItems{nullptr};

		QAction* _selectAllAction{nullptr};
		QAction* _deselectAllAction{nullptr};
		QAction* _invertSelectionAction{nullptr};
	};
}

#include "CheckListWidget.impl.h"

#endif
