/******************************************************************************
 * File: ObjectListItem.h
 * Date: 10.2.2018
 *****************************************************************************/

#ifndef OBJECTLISTITEM_H
#define OBJECTLISTITEM_H

#include <QListWidgetItem>

namespace grndr
{
	template<typename ObjectType>
	class ObjectListItem : public QListWidgetItem
	{
	public:
		ObjectListItem(ObjectType* object);

	public:
		virtual void updateItem() { }

	public:
		ObjectType* object() { return _object; }
		const ObjectType* object() const { return _object; }

	protected:
		ObjectType* _object{nullptr};
	};
}

#include "ObjectListItem.impl.h"

#endif
