/******************************************************************************
 * File: SliderValueWidget.h
 * Date: 15.6.2018
 *****************************************************************************/

#ifndef SLIDERVALUEWIDGET_H
#define SLIDERVALUEWIDGET_H

#include <QHBoxLayout>
#include <QSlider>
#include <QSpinBox>

namespace grndr
{
	class SliderValueWidget : public QWidget
	{
		Q_OBJECT

	public:
		SliderValueWidget(QString label, int minValue, int maxValue, QString valueSuffix = "", QWidget* parent = nullptr);

	public:
		int getValue() const { return _slider->value(); }
		void setValue(int value) { _slider->setValue(value); }

	signals:
		void valueChanged(int);

	private slots:
		void sliderValueChanged(int value);
		void spinBoxValueChanged(int value);

	private:
		QHBoxLayout* _layout{nullptr};

		QSlider* _slider{nullptr};
		QSpinBox* _spinBox{nullptr};
	};
}

#endif
