/******************************************************************************
 * File: CVUtils.h
 * Date: 19.2.2018
 *****************************************************************************/

#ifndef CVUTILS_H
#define CVUTILS_H

#include <QString>
#include <QImage>
#include <functional>
#include <opencv2/core.hpp>

namespace grndr
{
	class CVUtils final
	{
	public:
		static QImage matrixToImage(const cv::Mat& matrix);
		static QPixmap matrixToPixmap(const cv::Mat& matrix);

		template<typename DataType>
		static QString matrixToString(const cv::Mat& matrix);
		template<typename DataType>
		static QString matrixToString(const cv::Mat& matrix, std::function<QString(const DataType&)> formatter);

		static QColor colorToGrayscale(QColor color);
		static bool compareColors(QColor clr1, QColor clr2, float tolerance = 0.0f);

	private:
		CVUtils() { }
	};
}

#include "CVUtils.impl.h"

#endif
