/******************************************************************************
 * File: CVUtils.impl.h
 * Date: 19.2.2018
 *****************************************************************************/

#include "Grinder.h"
#include "CVUtils.h"

template<typename DataType>
QString CVUtils::matrixToString(const cv::Mat& matrix)
{
	// Default formatter: Use QString's arg function
	return matrixToString(matrix, [](const DataType& value) { return QString{"%1"}.arg(value); });
}

template<typename DataType>
QString CVUtils::matrixToString(const cv::Mat& matrix, std::function<QString(const DataType&)> formatter)
{
	QStringList entries;
	QString stringRep;

	for (int r = 0; r < matrix.rows; ++r)
	{
		entries.clear();

		for (int c = 0; c < matrix.cols; ++c)
			entries << formatter(matrix.at<DataType>(r, c));

		if (r != 0)
			stringRep += "\n";

		stringRep += entries.join(", ");
	}

	return stringRep;
}
