/******************************************************************************
 * File: FileUtils.cpp
 * Date: 10.2.2018
 *****************************************************************************/

#include "Grinder.h"
#include "FileUtils.h"

bool FileUtils::compareFileNames(QString fileName1, QString fileName2)
{
	fileName1.replace('\\', '/');
	fileName2.replace('\\', '/');

	return fileName1.toLower() == fileName2.toLower();
}

QStringList FileUtils::expandFileList(QStringList paths, QStringList filters)
{
	QStringList files;

	for (auto path : paths)
	{
		QFileInfo fileInfo{path};

		if (fileInfo.isDir())
		{
			QDirIterator dirIt{fileInfo.filePath(), filters, QDir::NoFilter, QDirIterator::Subdirectories};

			while (dirIt.hasNext())
			{
				auto file = dirIt.next();

				if (dirIt.fileInfo().isFile())
					files << file;
			}
		}
		else
			files << path;
	}

	return files;
}

QStringList FileUtils::getDirectoryList(QString path)
{
	QStringList dirs;
	QFileInfo fileInfo{path};

	if (fileInfo.isDir())
	{
		dirs << path;

		QDirIterator dirIt{fileInfo.filePath(), QDir::Dirs|QDir::NoDotAndDotDot, QDirIterator::Subdirectories};

		while (dirIt.hasNext())
		{
			auto dir = dirIt.next();

			if (dirIt.fileInfo().isDir())
				dirs << dir;
		}
	}

	return dirs;
}
