/******************************************************************************
 * File: SerializationUtils.h
 * Date: 01.3.2018
 *****************************************************************************/

#ifndef SERIALIZATIONUTILS_H
#define SERIALIZATIONUTILS_H

#include "common/serialization/SerializationContext.h"
#include "common/serialization/DeserializationContext.h"

namespace grndr
{
	class SerializationUtils final
	{
	public:
		template<typename ContainerType>
		static void serializeContainer(const ContainerType& container, QString elemName, SerializationContext& ctx, std::function<bool(const typename ContainerType::value_type&)> predicate = nullptr);
		template<typename ContainerType>
		static void deserializeContainer(QString elemName, DeserializationContext& ctx, std::function<typename ContainerType::value_type(const SettingsContainer&)> objCreator);

	private:
		SerializationUtils() { }
	};
}

#include "SerializationUtils.impl.h"

#endif
