/******************************************************************************
 * File: SerializationUtils.impl.h
 * Date: 01.3.2018
 *****************************************************************************/

#include "Grinder.h"
#include "SerializationUtils.h"

template<typename ContainerType>
void SerializationUtils::serializeContainer(const ContainerType& container, QString elemName, SerializationContext& ctx, std::function<bool(const typename ContainerType::value_type&)> predicate)
{
	for (const auto& object : container)
	{
		if (!predicate || predicate(object))
		{
			ctx.beginGroup(elemName);
			object->serialize(ctx);
			ctx.endGroup();
		}
	}
}

template<typename ContainerType>
void SerializationUtils::deserializeContainer(QString elemName, DeserializationContext& ctx, std::function<typename ContainerType::value_type(const SettingsContainer&)> objCreator)
{
	for (const auto elemSettings : ctx.settings().children(elemName))
	{
		ctx.beginGroup(elemSettings);

		if (auto object = objCreator(*elemSettings))
			object->deserialize(ctx);

		ctx.endGroup();
	}
}
